package model

// generated with yago. Better NOT to edit!

import (
	"database/sql"
	"fmt"
	"reflect"

	"github.com/slicebit/qb"

	"github.com/orus-io/yago"
)

const (
	// JobID is the ID field name
	JobID = "ID"
	// JobIDColumnName is the ID field associated column name
	JobIDColumnName = "id"
	// JobProcessID is the ProcessID field name
	JobProcessID = "ProcessID"
	// JobProcessIDColumnName is the ProcessID field associated column name
	JobProcessIDColumnName = "process_id"
	// JobActorID is the ActorID field name
	JobActorID = "ActorID"
	// JobActorIDColumnName is the ActorID field associated column name
	JobActorIDColumnName = "actor_id"
	// JobNodeID is the NodeID field name
	JobNodeID = "NodeID"
	// JobNodeIDColumnName is the NodeID field associated column name
	JobNodeIDColumnName = "node_id"
	// JobDetached is the Detached field name
	JobDetached = "Detached"
	// JobDetachedColumnName is the Detached field associated column name
	JobDetachedColumnName = "detached"
	// JobStatus is the Status field name
	JobStatus = "Status"
	// JobStatusColumnName is the Status field associated column name
	JobStatusColumnName = "status"
)

const (
	// JobTableName is the Job associated table name
	JobTableName = "job"
)

var jobTable = qb.Table(
	JobTableName,
	qb.Column(JobIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(JobProcessIDColumnName, qb.UUID()).NotNull(),
	qb.Column(JobActorIDColumnName, qb.UUID()).NotNull(),
	qb.Column(JobNodeIDColumnName, qb.Varchar()).NotNull(),
	qb.Column(JobDetachedColumnName, qb.Boolean()).NotNull(),
	qb.Column(JobStatusColumnName, qb.Varchar()).NotNull(),
	qb.UniqueKey(
		JobProcessIDColumnName,
		JobActorIDColumnName,
		JobNodeIDColumnName,
	),
)

var jobType = reflect.TypeOf(Job{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Job) StructType() reflect.Type {
	return jobType
}

// JobModel provides direct access to helpers for Job
// queries
type JobModel struct {
	mapper    *JobMapper
	ID        yago.ScalarField
	ProcessID yago.ScalarField
	ActorID   yago.ScalarField
	NodeID    yago.ScalarField
	Detached  yago.ScalarField
	Status    yago.MarshaledScalarField
}

// NewJobModel returns a new JobModel
func NewJobModel(meta *yago.Metadata) JobModel {
	mapper := NewJobMapper()
	meta.AddMapper(mapper)
	return JobModel{
		mapper:    mapper,
		ID:        yago.NewScalarField(mapper.Table().C(JobIDColumnName)),
		ProcessID: yago.NewScalarField(mapper.Table().C(JobProcessIDColumnName)),
		ActorID:   yago.NewScalarField(mapper.Table().C(JobActorIDColumnName)),
		NodeID:    yago.NewScalarField(mapper.Table().C(JobNodeIDColumnName)),
		Detached:  yago.NewScalarField(mapper.Table().C(JobDetachedColumnName)),
		Status:    yago.NewMarshaledScalarField(mapper.Table().C(JobStatusColumnName)),
	}
}

// GetMapper returns the associated JobMapper instance
func (m JobModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewJobMapper initialize a NewJobMapper
func NewJobMapper() *JobMapper {
	m := &JobMapper{}
	return m
}

// JobMapper is the Job mapper
type JobMapper struct{}

// GetMapper returns itself
func (mapper *JobMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*JobMapper) Name() string {
	return "model/Job"
}

// Table returns the mapper table
func (*JobMapper) Table() *qb.TableElem {
	return &jobTable
}

// StructType returns the reflect.Type of the mapped structure
func (JobMapper) StructType() reflect.Type {
	return jobType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper JobMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Job)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Job{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[JobIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, JobProcessID) {
		m[JobProcessIDColumnName] = s.ProcessID
	}
	if allValues || yago.StringListContains(fields, JobActorID) {
		m[JobActorIDColumnName] = s.ActorID
	}
	if allValues || yago.StringListContains(fields, JobNodeID) {
		m[JobNodeIDColumnName] = s.NodeID
	}
	if allValues || yago.StringListContains(fields, JobDetached) {
		m[JobDetachedColumnName] = s.Detached
	}
	if allValues || yago.StringListContains(fields, JobStatus) {
		if b, err := s.Status.MarshalText(); err == nil {
			m[JobStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper JobMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		jobTable.C(JobIDColumnName),
		jobTable.C(JobProcessIDColumnName),
		jobTable.C(JobActorIDColumnName),
		jobTable.C(JobNodeIDColumnName),
		jobTable.C(JobDetachedColumnName),
		jobTable.C(JobStatusColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper JobMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Job)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Job{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper JobMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Job)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Job{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	var StatusText []byte
	if err := rows.Scan(
		&s.ID,
		&s.ProcessID,
		&s.ActorID,
		&s.NodeID,
		&s.Detached,
		&StatusText,
	); err != nil {
		return err
	}
	if err := s.Status.UnmarshalText(StatusText); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (JobMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (JobMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*Job)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper JobMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Job)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper JobMapper) PKeyClause(values []interface{}) qb.Clause {
	return jobTable.C(JobIDColumnName).Eq(values[0])
}
